VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "comdlg32.ocx"
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3195
   ClientLeft      =   165
   ClientTop       =   450
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.ComboBox cmbMethod 
      Height          =   315
      Left            =   2760
      TabIndex        =   7
      Text            =   "Select Method"
      Top             =   600
      Width           =   1815
   End
   Begin VB.CommandButton cmdQuit 
      Caption         =   "Quit"
      Height          =   495
      Left            =   3000
      TabIndex        =   6
      Top             =   1080
      Width           =   1215
   End
   Begin VB.CommandButton cmdParse 
      Caption         =   "Parse"
      Enabled         =   0   'False
      Height          =   495
      Left            =   1560
      TabIndex        =   5
      Top             =   1080
      Width           =   1215
   End
   Begin VB.ListBox lstParse 
      Height          =   1425
      Left            =   120
      TabIndex        =   4
      Top             =   1680
      Width           =   4455
   End
   Begin VB.CommandButton cmdOpen 
      Caption         =   "File ..."
      Height          =   495
      Left            =   120
      TabIndex        =   3
      Top             =   1080
      Width           =   1215
   End
   Begin VB.ComboBox cmbDelim 
      Height          =   315
      Left            =   1080
      TabIndex        =   2
      Text            =   "Select Delimeter"
      Top             =   600
      Width           =   1575
   End
   Begin MSComDlg.CommonDialog cdl 
      Left            =   4200
      Top             =   120
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
      DialogTitle     =   "Select file to parse"
      Filter          =   "Text Files|*.txt|All Files|*.*"
   End
   Begin VB.Label Label1 
      Caption         =   "Delimeter"
      Height          =   255
      Left            =   120
      TabIndex        =   1
      Top             =   600
      Width           =   855
   End
   Begin VB.Label lblFileName 
      Height          =   375
      Left            =   0
      TabIndex        =   0
      Top             =   120
      Width           =   4575
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' VB Parse
' Examples of how to parse strings in Visual Basic
' The main part of the code is in parse_instr and parse_split

Option Explicit

Dim FirstTime As Boolean
Dim FileName As String
Dim Delim As String
Const FileNum = 1

Private Sub cmdOpen_Click()
    cdl.Action = 1
    FileName = cdl.FileName
    lblFileName.Caption = "Parse File " & FileName
    cmdParse.Enabled = True
End Sub

Private Sub cmdParse_Click()
    lstParse.Clear  ' clear results
    Open FileName For Input As #FileNum
    parse_file
    Close #FileNum
End Sub

Private Sub cmdQuit_Click()
    Unload Me
End Sub

Private Sub Form_Activate()
    If FirstTime Then
        form_init
        FirstTime = False
    End If
End Sub

Private Sub Form_Load()
    FirstTime = True
End Sub


Sub form_init()
    ' cdl.Filter = "*.txt|Text Files"
    cmbDelim.AddItem "Vertical Bar"
    cmbDelim.AddItem "Comma"
    cmbDelim.AddItem "Space"
    cmbDelim.AddItem "Tab"
    
    cmbMethod.AddItem "Instr"
    cmbMethod.AddItem "Split"
End Sub
Sub parse_file()
    ' User has asked to parse the file
    ' Get the delimeter to be used & the method
    ' then call the appropriate routine
    ' If something not selected, don't parse file
    
    ' get delimeter based on selection from combo box
    Select Case cmbDelim.ListIndex
    Case 0
        Delim = "|"
    Case 1
        Delim = ","
    Case 2
        Delim = " "
    Case 4
        Delim = vbTab
    Case Else
        MsgBox "Invalid delimeter selected"
        Exit Sub    ' don't parse file
    End Select
    
    ' get method based on selection from combo box
    Select Case cmbMethod.ListIndex
    Case 0
        parse_instr
    Case 1
        parse_split
    Case Else
        MsgBox "Invalid method selected"
    End Select
End Sub
Sub parse_instr()
    ' This routine parses fields one at a time
    ' This basic technique can be used by any language
    ' that can handle individual characters within a string
    
    ' We will keep extracting the next field from the line
    ' then we will process the rest of the line
    ' As long as there is a delimeter in the line,
    ' we have more fields
    ' Whenever there isn't any delimeter,
    ' the rest of the line is the last delimeter
    
    Dim rec As Integer  ' current record number from file
    Dim fld As Integer  ' current field in line
    Dim p As Integer    ' location of delimeter (0 means not found)
    Dim InLine As String ' input line that was read from file
    Dim s As String     ' the current field from line
    
    ' keep reading lines from input file until end-of-file
    Do While Not EOF(FileNum)
        Line Input #FileNum, InLine ' read line into InLine
        rec = rec + 1   ' we have another record
        fld = 0         ' no fields yet
        Do While Len(InLine) > 0    ' get all fields
            fld = fld + 1   ' got another field
            p = InStr(InLine, Delim)    ' look for delimeter
            If p <= 0 Then
                ' no delimeter - this is the last field
                s = InLine  ' field is entire line
                InLine = "" ' no fields remaining
            Else
                ' delimeter found at p - get next field
                s = Left(InLine, p - 1) ' extract field
                InLine = Mid(InLine, p + 1) ' rest of line
            End If
            
            ' next field in s - add to list
            lstParse.AddItem "Rec " & rec & ", fld " & fld & "=" & s
            
        Loop ' end loop thru fields in line
    Loop ' end loop thru file
    

End Sub
Sub parse_split()
    ' This routine parses the file using the Split method
    ' This method appears in several languages
    ' it first appeared in AWK, and was copied in Perl
    ' The split_flds package by Bill Pringle allows you
    ' to do the same thing in C
    
    Dim flds() As String    ' array of fields from line
    Dim InLine As String    ' input line from file
    Dim rec As Integer      ' current line number
    Dim fld As Integer      ' current field number
    Dim flds As Integer     ' how many fields there are
    
    Do While Not EOF(FileNum) ' loop until end of file
        Line Input #FileNum, InLine ' read next line
        rec = rec + 1   ' another line read
        fld = 0         ' no fields yet
        flds = Split(InLine, Delim) ' get all fields into array
        For fld = 0 To UBound(flds, 1)
            lstParse.AddItem "Rec " & rec & ", fld " & fld + 1 & "=" & flds(fld)
        Next    ' end loop thru fields
     Loop ' end loop thru lines in file
    
End Sub
